=== modified file '.bzrignore'
--- .bzrignore	2011-04-03 16:54:43 +0000
+++ .bzrignore	2011-04-04 21:37:55 +0000
@@ -351,3 +351,5 @@
 drizzled/message/catalog_writer
 drizzled/message/replication_options.pb.cc
 drizzled/message/replication_options.pb.h
+drizzled/message/access.pb.cc
+drizzled/message/access.pb.h

=== modified file 'drizzled/identifier.h'
--- drizzled/identifier.h	2011-03-28 14:32:36 +0000
+++ drizzled/identifier.h	2011-04-04 21:37:55 +0000
@@ -49,3 +49,4 @@
 // Constant identifiers used internally
 #include <drizzled/identifier/constants/schema.h>
 #include <drizzled/identifier/constants/table.h>
+#include <drizzled/identifier/constants/user.h>

=== added file 'drizzled/identifier/constants/user.cc'
--- drizzled/identifier/constants/user.cc	1970-01-01 00:00:00 +0000
+++ drizzled/identifier/constants/user.cc	2011-04-03 06:02:00 +0000
@@ -0,0 +1,57 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2011 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <config.h>
+
+#include <drizzled/identifier.h>
+
+namespace drizzled {
+namespace identifier {
+namespace constants {
+
+// Please note, UTF8 id's should not be used with this class
+class User : public identifier::User
+{
+public:
+  User(const std::string &name) :
+    identifier::User(name)
+  {
+  }
+
+  const std::string &getPath() const
+  {
+    return _path;
+  }
+
+private:
+  std::string _path;
+};
+
+} /* namespace constants */
+
+identifier::User::const_reference system_user()
+{
+  static drizzled::identifier::User _tmp("SYSTEM");
+
+  return _tmp;
+}
+
+} /* namespace identifier */
+} /* namespace drizzled */

=== added file 'drizzled/identifier/constants/user.h'
--- drizzled/identifier/constants/user.h	1970-01-01 00:00:00 +0000
+++ drizzled/identifier/constants/user.h	2011-04-04 21:37:55 +0000
@@ -0,0 +1,31 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2011 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#pragma once
+
+namespace drizzled {
+namespace identifier {
+
+const identifier::User& system_user();
+
+} /* namespace identifier */
+} /* namespace drizzled */
+
+#define SYSTEM_USER drizzled::identifier::system_user()

=== modified file 'drizzled/identifier/user.h'
--- drizzled/identifier/user.h	2011-03-28 17:55:27 +0000
+++ drizzled/identifier/user.h	2011-04-04 21:37:55 +0000
@@ -50,10 +50,16 @@
     password_type(NONE)
   { }
 
+  User(const std::string username_arg):
+    password_type(NONE),
+    _user(username_arg),
+    _address("")
+  { }
+
   virtual std::string getSQLPath() const
-	{
-		return _user.empty() ? "<no user>" : _user;
-	}
+  {
+    return _user.empty() ? "<no user>" : _user;
+  }
 
   bool hasPassword() const
   {

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2011-03-28 14:32:36 +0000
+++ drizzled/include.am	2011-04-04 21:37:55 +0000
@@ -227,6 +227,7 @@
 			      drizzled/hybrid_type_traits_integer.h \
 			      drizzled/identifier.h \
 			      drizzled/identifier/catalog.h \
+			      drizzled/identifier/constants/user.h \
 			      drizzled/identifier/constants/schema.h \
 			      drizzled/identifier/constants/table.h \
 			      drizzled/identifier/schema.h \
@@ -296,6 +297,7 @@
 			      drizzled/memory/root.h \
 			      drizzled/memory/sql_alloc.h \
 			      drizzled/message.h \
+			      drizzled/message/access.h \
 			      drizzled/message/cache.h \
 			      drizzled/message/catalog.h \
 			      drizzled/message/replication_options.h \
@@ -696,6 +698,7 @@
 			   drizzled/identifier/catalog.cc \
 			   drizzled/identifier/constants/schema.cc \
 			   drizzled/identifier/constants/table.cc \
+			   drizzled/identifier/constants/user.cc \
 			   drizzled/identifier/schema.cc \
 			   drizzled/identifier/table.cc \
 			   drizzled/identifier/user.cc \

=== modified file 'drizzled/message.cc'
--- drizzled/message.cc	2011-02-17 00:14:13 +0000
+++ drizzled/message.cc	2011-04-03 06:02:00 +0000
@@ -26,9 +26,6 @@
 #include <drizzled/plugin/event_observer.h>
 #include <drizzled/message.h>
 
-#include <drizzled/message/table.pb.h>
-#include <drizzled/message/schema.pb.h>
-
 #include <string>
 
 namespace drizzled {

=== modified file 'drizzled/message.h'
--- drizzled/message.h	2011-03-22 23:52:29 +0000
+++ drizzled/message.h	2011-04-04 21:37:55 +0000
@@ -20,17 +20,17 @@
 
 #pragma once
 
+#include <drizzled/message/access.h>
+#include <drizzled/message/replication_options.h>
+#include <drizzled/message/schema.h>
 #include <drizzled/message/table.h>
-#include <drizzled/message/schema.h>
-#include <drizzled/message/replication_options.h>
 #if 0
 #include <drizzled/message/transaction.pb.h>
 #include <google/protobuf/text_format.h>
 #endif
+
 #include <drizzled/identifier.h>
 
-#include <boost/shared_ptr.hpp>
-
 namespace drizzled {
 namespace message {
 

=== added file 'drizzled/message/access.h'
--- drizzled/message/access.h	1970-01-01 00:00:00 +0000
+++ drizzled/message/access.h	2011-04-03 06:02:00 +0000
@@ -0,0 +1,56 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2011 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#pragma once
+
+#include <drizzled/identifier.h>
+#include <drizzled/message/access.pb.h>
+
+namespace drizzled {
+namespace message {
+
+template<class T> void set_definer(T& reference, const identifier::User &arg)
+{
+  message::Access *access= reference.mutable_access();
+  access->set_definer(arg.username());
+}
+
+template<class T> bool has_definer(const T& reference)
+{
+  if (reference.has_access() and reference.access().has_definer() and (not reference.access().definer().empty()))
+  {
+    return true;
+  }
+
+  return false;
+}
+
+template<class T> const char *definer(const T& reference)
+{
+  if (reference.has_access() and reference.access().has_definer())
+  {
+    return reference.access().definer().c_str();
+  }
+
+  return ""; // Hardcoded because of dependency issue with message library on identifier
+}
+
+} /* namespace message */
+} /* namespace drizzled */

=== added file 'drizzled/message/access.proto'
--- drizzled/message/access.proto	1970-01-01 00:00:00 +0000
+++ drizzled/message/access.proto	2011-04-03 06:02:00 +0000
@@ -0,0 +1,13 @@
+/*
+  Represents access objects.
+*/
+package drizzled.message;
+option optimize_for = SPEED;
+
+option java_package = "org.drizzle.messages";
+option java_outer_classname = "Access";
+
+message Access {
+    optional string definer= 1;
+    optional string invoker= 2;
+}

=== modified file 'drizzled/message/include.am'
--- drizzled/message/include.am	2011-02-28 01:22:25 +0000
+++ drizzled/message/include.am	2011-04-04 21:37:55 +0000
@@ -50,6 +50,7 @@
 						       drizzled/message/catalog.pb.cc \
 						       drizzled/message/engine.pb.cc \
 						       drizzled/message/event.pb.cc \
+						       drizzled/message/access.pb.cc \
 						       drizzled/message/replication_options.pb.cc \
 						       drizzled/message/resultset.pb.cc \
 						       drizzled/message/schema.pb.cc \
@@ -61,6 +62,7 @@
 				drizzled/message/catalog.pb.h \
 				drizzled/message/engine.pb.h \
 				drizzled/message/event.pb.h \
+				drizzled/message/access.pb.h \
 				drizzled/message/replication_options.pb.h \
 				drizzled/message/resultset.pb.h \
 				drizzled/message/schema.pb.h \
@@ -107,6 +109,7 @@
 	      ${MESSAGE_DIR}/catalog.proto \
 	      ${MESSAGE_DIR}/engine.proto \
 	      ${MESSAGE_DIR}/event.proto \
+	      ${MESSAGE_DIR}/access.proto \
 	      ${MESSAGE_DIR}/replication_options.proto \
 	      ${MESSAGE_DIR}/resultset.proto \
 	      ${MESSAGE_DIR}/schema.proto \
@@ -118,6 +121,7 @@
 		 ${MESSAGE_DIR}/catalog.pb.h \
 		 ${MESSAGE_DIR}/engine.pb.h \
 		 ${MESSAGE_DIR}/event.pb.h \
+		 ${MESSAGE_DIR}/access.pb.h \
 		 ${MESSAGE_DIR}/replication_options.pb.h \
 		 ${MESSAGE_DIR}/resultset.pb.h \
 		 ${MESSAGE_DIR}/schema.pb.h \
@@ -133,6 +137,8 @@
 	      ${MESSAGE_DIR}/engine.pb.h \
 	      ${MESSAGE_DIR}/event.pb.cc \
 	      ${MESSAGE_DIR}/event.pb.h \
+	      ${MESSAGE_DIR}/access.pb.cc \
+	      ${MESSAGE_DIR}/access.pb.h \
 	      ${MESSAGE_DIR}/replication_options.pb.cc \
 	      ${MESSAGE_DIR}/replication_options.pb.h \
 	      ${MESSAGE_DIR}/resultset.pb.cc \

=== removed file 'drizzled/message/replication_options.h'
--- drizzled/message/replication_options.h	2011-03-22 23:52:29 +0000
+++ drizzled/message/replication_options.h	1970-01-01 00:00:00 +0000
@@ -1,47 +0,0 @@
-/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2011 Brian Aker
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#pragma once
-
-#include <drizzled/message/replication_options.pb.h>
-
-namespace drizzled {
-namespace message {
-
-template<class T> bool is_replicated(const T& reference)
-{
-  if (reference.has_replication_options() and
-      reference.replication_options().has_is_replicated())
-  {
-    return reference.replication_options().is_replicated();
-  }
-
-  return true;
-}
-
-template<class T> void set_is_replicated(T& reference, bool arg)
-{
-  message::ReplicationOptions *options= reference.mutable_replication_options();
-  options->set_is_replicated(arg);
-}
-
-} /* namespace message */
-} /* namespace drizzled */
-

=== added file 'drizzled/message/replication_options.h'
--- drizzled/message/replication_options.h	1970-01-01 00:00:00 +0000
+++ drizzled/message/replication_options.h	2011-04-03 06:02:00 +0000
@@ -0,0 +1,47 @@
+/* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Brian Aker
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#pragma once
+
+#include <drizzled/message/replication_options.pb.h>
+
+namespace drizzled {
+namespace message {
+
+template<class T> bool is_replicated(const T& reference)
+{
+  if (reference.has_replication_options() and
+      reference.replication_options().has_is_replicated())
+  {
+    return reference.replication_options().is_replicated();
+  }
+
+  return true;
+}
+
+template<class T> void set_is_replicated(T& reference, bool arg)
+{
+  message::ReplicationOptions *options= reference.mutable_replication_options();
+  options->set_is_replicated(arg);
+}
+
+} /* namespace message */
+} /* namespace drizzled */

=== modified file 'drizzled/message/schema.proto'
--- drizzled/message/schema.proto	2011-02-16 22:38:23 +0000
+++ drizzled/message/schema.proto	2011-04-03 06:02:00 +0000
@@ -8,6 +8,7 @@
 option java_outer_classname = "SchemaMessage";
 
 import "engine.proto";
+import "access.proto";
 import "replication_options.proto";
 
 message Schema {
@@ -26,4 +27,5 @@
   optional uint64 version = 14;
   optional Options options = 15;
   optional ReplicationOptions replication_options= 16;
+  optional Access access= 17;
 }

=== modified file 'drizzled/message/statement_transform.cc'
--- drizzled/message/statement_transform.cc	2011-03-29 09:33:49 +0000
+++ drizzled/message/statement_transform.cc	2011-04-04 21:37:55 +0000
@@ -39,6 +39,7 @@
 #include <drizzled/message.h>
 #include <drizzled/message/statement_transform.h>
 #include <drizzled/message/transaction.pb.h>
+#include <drizzled/message/access.h>
 
 #include <string>
 #include <vector>
@@ -892,6 +893,12 @@
     destination.append(" REPLICATE = FALSE");
   }
 
+  if (message::has_definer(schema))
+  {
+    destination.append(" DEFINER ");
+    destination.append(message::definer(schema));
+  }
+
   return NONE;
 }
 
@@ -1090,6 +1097,12 @@
     destination.append(" REPLICATE = FALSE");
   }
 
+  if (message::has_definer(table))
+  {
+    destination.append(" DEFINER ");
+    destination.append(message::definer(table));
+  }
+
   return NONE;
 }
 

=== modified file 'drizzled/message/table.proto'
--- drizzled/message/table.proto	2011-03-24 18:19:30 +0000
+++ drizzled/message/table.proto	2011-04-04 21:37:55 +0000
@@ -8,6 +8,7 @@
 option java_outer_classname = "TableMessage";
 
 import "engine.proto";
+import "access.proto";
 import "replication_options.proto";
 
 message Table {
@@ -194,6 +195,7 @@
   optional uint64 version = 15;
 
   optional ReplicationOptions replication_options= 16;
+  optional Access access= 17;
 }
 
 message AddedFields {

=== modified file 'drizzled/parser.cc'
--- drizzled/parser.cc	2011-03-28 02:46:21 +0000
+++ drizzled/parser.cc	2011-04-04 21:37:55 +0000
@@ -322,6 +322,19 @@
   opt->set_state(value.str, value.length);
 }
 
+void buildSchemaDefiner(LEX *lex, const LEX_STRING &value)
+{
+  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  identifier::User user(value.str);
+  message::set_definer(statement->schema_message, user);
+}
+
+void buildSchemaDefiner(LEX *lex, const identifier::User &user)
+{
+  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  message::set_definer(statement->schema_message, user);
+}
+
 void buildSchemaOption(LEX *lex, const char *key, uint64_t value)
 {
   statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;

=== modified file 'drizzled/parser.h'
--- drizzled/parser.h	2011-03-28 22:16:45 +0000
+++ drizzled/parser.h	2011-04-04 21:37:55 +0000
@@ -128,6 +128,8 @@
 void buildEngineOption(LEX *lex, const char *key, uint64_t value);
 void buildSchemaOption(LEX *lex, const char *key, const LEX_STRING &value);
 void buildSchemaOption(LEX *lex, const char *key, uint64_t value);
+void buildSchemaDefiner(LEX *lex, const LEX_STRING &value);
+void buildSchemaDefiner(LEX *lex, const identifier::User &user);
 bool checkFieldIdent(LEX *lex, const LEX_STRING &schema_name, const LEX_STRING &table_name);
 
 Item *buildIdent(LEX *lex, const LEX_STRING &schema_name, const LEX_STRING &table_name, const LEX_STRING &field_name);

=== modified file 'drizzled/plugin/table_function.cc'
--- drizzled/plugin/table_function.cc	2011-03-14 17:27:03 +0000
+++ drizzled/plugin/table_function.cc	2011-04-03 06:02:00 +0000
@@ -41,6 +41,7 @@
   proto.set_creation_timestamp(0);
   proto.set_update_timestamp(0);
   message::set_is_replicated(proto, false);
+  message::set_definer(proto, SYSTEM_USER);
 }
 
 bool plugin::TableFunction::addPlugin(plugin::TableFunction *tool)

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-04-03 16:54:43 +0000
+++ drizzled/sql_yacc.yy	2011-04-04 21:37:55 +0000
@@ -180,7 +180,7 @@
   Currently there are 70 shift/reduce conflicts.
   We should not introduce new conflicts any more.
 */
-%expect 79
+%expect 80
 
 /*
    Comments for TOKENS.
@@ -201,8 +201,8 @@
 
 %token  ABORT_SYM                     /* INTERNAL (used in lex) */
 %token  ACTION                        /* SQL-2003-N */
+%token  ADDDATE_SYM                   /* MYSQL-FUNC */
 %token  ADD_SYM                           /* SQL-2003-R */
-%token  ADDDATE_SYM                   /* MYSQL-FUNC */
 %token  AFTER_SYM                     /* SQL-2003-N */
 %token  AGGREGATE_SYM
 %token  ALL                           /* SQL-2003-R */
@@ -283,6 +283,7 @@
 %token  DECIMAL_SYM                   /* SQL-2003-R */
 %token  DECLARE_SYM                   /* SQL-2003-R */
 %token  DEFAULT                       /* SQL-2003-R */
+%token  DEFINER
 %token  DELETE_SYM                    /* SQL-2003-R */
 %token  DESC                          /* SQL-2003-N */
 %token  DESCRIBE                      /* SQL-2003-R */
@@ -291,8 +292,8 @@
 %token  DISCARD
 %token  DISTINCT                      /* SQL-2003-R */
 %token  DIV_SYM
+%token  DOUBLE_SYM                    /* SQL-2003-R */
 %token  DO_SYM
-%token  DOUBLE_SYM                    /* SQL-2003-R */
 %token  DROP                          /* SQL-2003-R */
 %token  DUMPFILE
 %token  DUPLICATE_SYM
@@ -330,8 +331,8 @@
 %token  FULL                          /* SQL-2003-R */
 %token  GE
 %token  GLOBAL_SYM                    /* SQL-2003-R */
+%token  GROUP_CONCAT_SYM
 %token  GROUP_SYM                     /* SQL-2003-R */
-%token  GROUP_CONCAT_SYM
 %token  HASH_SYM
 %token  HAVING                        /* SQL-2003-R */
 %token  HEX_NUM
@@ -356,6 +357,7 @@
 %token  INTERVAL_SYM                  /* SQL-2003-R */
 %token  INTO                          /* SQL-2003-R */
 %token  INT_SYM                       /* SQL-2003-R */
+%token  INVOKER
 %token  IN_SYM                        /* SQL-2003-R */
 %token  IS                            /* SQL-2003-R */
 %token  ISOLATION                     /* SQL-2003-R */
@@ -440,8 +442,8 @@
 %token  READ_WRITE_SYM
 %token  REAL                          /* SQL-2003-R */
 %token  REDUNDANT_SYM
+%token  REFERENCES                    /* SQL-2003-R */
 %token  REGEXP_SYM
-%token  REFERENCES                    /* SQL-2003-R */
 %token  RELEASE_SYM                   /* SQL-2003-R */
 %token  RENAME
 %token  REPEATABLE_SYM                /* SQL-2003-N */
@@ -469,8 +471,8 @@
 %token  SEPARATOR_SYM
 %token  SERIALIZABLE_SYM              /* SQL-2003-N */
 %token  SERIAL_SYM
+%token  SERVER_SYM
 %token  SESSION_SYM                   /* SQL-2003-N */
-%token  SERVER_SYM
 %token  SET_SYM                       /* SQL-2003-R */
 %token  SET_VAR
 %token  SHARE_SYM
@@ -511,10 +513,10 @@
 %token  TEXT_STRING
 %token  TEXT_SYM
 %token  THEN_SYM                      /* SQL-2003-R */
-%token  TIME_SYM                 /* SQL-2003-R */
-%token  TIMESTAMP_SYM                 /* SQL-2003-R */
 %token  TIMESTAMP_ADD
 %token  TIMESTAMP_DIFF
+%token  TIMESTAMP_SYM                 /* SQL-2003-R */
+%token  TIME_SYM                 /* SQL-2003-R */
 %token  TO_SYM                        /* SQL-2003-R */
 %token  TRAILING                      /* SQL-2003-R */
 %token  TRANSACTION_SYM
@@ -1001,6 +1003,14 @@
           {
             parser::buildReplicationOption(&Lex, false);
           }
+        | DEFINER TEXT_STRING_sys
+          {
+            parser::buildSchemaDefiner(&Lex, $2);
+          }
+        | DEFINER CURRENT_USER optional_braces
+          {
+            parser::buildSchemaDefiner(&Lex, *session->user());
+          }
         | ident_or_text '=' ident_or_text
           {
             parser::buildSchemaOption(&Lex, $1.str, $3);
@@ -1060,6 +1070,15 @@
           {
 	    message::set_is_replicated(*Lex.table(), false);
           }
+        | DEFINER TEXT_STRING_sys
+          {
+	    drizzled::identifier::User user($2.str);
+            message::set_definer(*Lex.table(), user);
+          }
+        | DEFINER CURRENT_USER optional_braces
+          {
+            message::set_definer(*Lex.table(), *session->user());
+          }
         |  ROW_FORMAT_SYM '=' row_format_or_text
           {
             parser::buildEngineOption(&Lex, "ROW_FORMAT", $3);

=== modified file 'drizzled/statement/create_schema.cc'
--- drizzled/statement/create_schema.cc	2011-03-23 14:35:15 +0000
+++ drizzled/statement/create_schema.cc	2011-04-04 21:37:55 +0000
@@ -54,6 +54,8 @@
 
   drizzled::message::schema::init(schema_message, lex().name.str);
 
+  message::set_definer(schema_message, *session().user());
+
   bool res = false;
   std::string path = schema_identifier.getSQLPath();
 

=== modified file 'drizzled/symbol_hash.gperf'
--- drizzled/symbol_hash.gperf	2011-04-03 03:26:12 +0000
+++ drizzled/symbol_hash.gperf	2011-04-04 21:37:55 +0000
@@ -132,6 +132,7 @@
 DECIMAL, DECIMAL_SYM
 DECLARE, DECLARE_SYM
 DEFAULT, DEFAULT
+DEFINER, DEFINER
 DELETE, DELETE_SYM
 DESC, DESC
 DESCRIBE, DESCRIBE
@@ -204,6 +205,7 @@
 INTEGER, INT_SYM
 INTERVAL, INTERVAL_SYM
 INTO, INTO
+INVOKER, INVOKER
 IS, IS
 ISOLATION, ISOLATION
 ITERATE, ITERATE_SYM

=== modified file 'plugin/collation_dictionary/tests/r/data_dictionary.result'
--- plugin/collation_dictionary/tests/r/data_dictionary.result	2011-02-21 17:37:00 +0000
+++ plugin/collation_dictionary/tests/r/data_dictionary.result	2011-04-03 06:02:00 +0000
@@ -6,7 +6,7 @@
   `DEFAULT_COLLATE_NAME` VARCHAR(256) NOT NULL,
   `DESCRIPTION` VARCHAR(256) NOT NULL,
   `MAXLEN` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table COLLATIONS ;
 Table	Create Table
 COLLATIONS	CREATE TABLE `COLLATIONS` (
@@ -17,7 +17,7 @@
   `IS_DEFAULT` BOOLEAN NOT NULL,
   `IS_COMPILED` BOOLEAN NOT NULL,
   `SORTLEN` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SELECT * FROM character_sets ORDER BY CHARACTER_SET_NAME;
 CHARACTER_SET_NAME	DEFAULT_COLLATE_NAME	DESCRIPTION	MAXLEN
 binary	binary		1

=== modified file 'plugin/filtered_replicator/tests/r/var_filteredschemas.result'
--- plugin/filtered_replicator/tests/r/var_filteredschemas.result	2011-01-18 17:30:41 +0000
+++ plugin/filtered_replicator/tests/r/var_filteredschemas.result	2011-04-03 06:02:00 +0000
@@ -11,7 +11,7 @@
 We should only see the 'bar' schema in the log
 
 SET AUTOCOMMIT=0;
-CREATE SCHEMA `bar` COLLATE utf8_general_ci;
+CREATE SCHEMA `bar` COLLATE utf8_general_ci DEFINER root;
 COMMIT;
 SET AUTOCOMMIT=0;
 DROP SCHEMA `bar`;

=== modified file 'plugin/filtered_replicator/tests/r/var_schemaregex.result'
--- plugin/filtered_replicator/tests/r/var_schemaregex.result	2011-01-18 17:30:41 +0000
+++ plugin/filtered_replicator/tests/r/var_schemaregex.result	2011-04-03 06:02:00 +0000
@@ -13,7 +13,7 @@
 We should only see the 'bar' schema in the log
 
 SET AUTOCOMMIT=0;
-CREATE SCHEMA `bar` COLLATE utf8_general_ci;
+CREATE SCHEMA `bar` COLLATE utf8_general_ci DEFINER root;
 COMMIT;
 SET AUTOCOMMIT=0;
 DROP SCHEMA `bar`;

=== modified file 'plugin/information_schema_dictionary/tests/r/show_create_table.result'
--- plugin/information_schema_dictionary/tests/r/show_create_table.result	2011-02-21 17:37:00 +0000
+++ plugin/information_schema_dictionary/tests/r/show_create_table.result	2011-04-03 06:02:00 +0000
@@ -6,7 +6,7 @@
   `CONSTRAINT_SCHEMA` VARCHAR(256) NOT NULL,
   `CONSTRAINT_NAME` VARCHAR(256) NOT NULL,
   `CHECK_CLAUSE` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `COLUMNS`;
 Table	Create Table
 COLUMNS	CREATE TABLE `COLUMNS` (
@@ -33,7 +33,7 @@
   `DOMAIN_CATALOG` VARCHAR(256) DEFAULT NULL,
   `DOMAIN_SCHEMA` VARCHAR(256) DEFAULT NULL,
   `DOMAIN_NAME` VARCHAR(256) DEFAULT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `COLUMN_DOMAIN_USAGE`;
 Table	Create Table
 COLUMN_DOMAIN_USAGE	CREATE TABLE `COLUMN_DOMAIN_USAGE` (
@@ -44,7 +44,7 @@
   `TABLE_SCHEMA` VARCHAR(256) NOT NULL,
   `TABLE_NAME` VARCHAR(256) NOT NULL,
   `COLUMN_NAME` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `COLUMN_PRIVILEGES`;
 Table	Create Table
 COLUMN_PRIVILEGES	CREATE TABLE `COLUMN_PRIVILEGES` (
@@ -56,7 +56,7 @@
   `COLUMN_NAME` VARCHAR(256) NOT NULL,
   `PRIVILEGE_TYPE` VARCHAR(256) NOT NULL,
   `IS_GRANTABLE` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `CONSTRAINT_COLUMN_USAGE`;
 Table	Create Table
 CONSTRAINT_COLUMN_USAGE	CREATE TABLE `CONSTRAINT_COLUMN_USAGE` (
@@ -67,7 +67,7 @@
   `CONSTRAINT_CATALOG` VARCHAR(256) NOT NULL,
   `CONSTRAINT_SCHEMA` VARCHAR(256) NOT NULL,
   `CONSTRAINT_NAME` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `CONSTRAINT_TABLE_USAGE`;
 Table	Create Table
 CONSTRAINT_TABLE_USAGE	CREATE TABLE `CONSTRAINT_TABLE_USAGE` (
@@ -77,7 +77,7 @@
   `CONSTRAINT_CATALOG` VARCHAR(256) NOT NULL,
   `CONSTRAINT_SCHEMA` VARCHAR(256) NOT NULL,
   `CONSTRAINT_NAME` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `DOMAINS`;
 Table	Create Table
 DOMAINS	CREATE TABLE `DOMAINS` (
@@ -98,7 +98,7 @@
   `NUMERIC_SCALE` VARCHAR(256) NOT NULL,
   `DATETIME_PRECISION` VARCHAR(256) NOT NULL,
   `DOMAIN_DEFAULT` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `DOMAIN_CONSTRAINTS`;
 Table	Create Table
 DOMAIN_CONSTRAINTS	CREATE TABLE `DOMAIN_CONSTRAINTS` (
@@ -110,7 +110,7 @@
   `DOMAIN_NAME` VARCHAR(256) NOT NULL,
   `IS_DEFERRABLE` BOOLEAN NOT NULL,
   `INITIALLY_DEFERRED` BOOLEAN NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `KEY_COLUMN_USAGE`;
 Table	Create Table
 KEY_COLUMN_USAGE	CREATE TABLE `KEY_COLUMN_USAGE` (
@@ -122,7 +122,7 @@
   `TABLE_NAME` VARCHAR(256) NOT NULL,
   `COLUMN_NAME` VARCHAR(256) NOT NULL,
   `ORDINAL_POSITION` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `PARAMETERS`;
 Table	Create Table
 PARAMETERS	CREATE TABLE `PARAMETERS` (
@@ -156,7 +156,7 @@
   `SCOPE_CATALOG` VARCHAR(256) NOT NULL,
   `SCOPE_SCHEMA` VARCHAR(256) NOT NULL,
   `SCOPE_NAME` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `REFERENTIAL_CONSTRAINTS`;
 Table	Create Table
 REFERENTIAL_CONSTRAINTS	CREATE TABLE `REFERENTIAL_CONSTRAINTS` (
@@ -169,7 +169,7 @@
   `MATCH_OPTION` VARCHAR(256) NOT NULL,
   `UPDATE_RULE` VARCHAR(256) NOT NULL,
   `DELETE_RULE` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `ROUTINES`;
 Table	Create Table
 ROUTINES	CREATE TABLE `ROUTINES` (
@@ -226,7 +226,7 @@
   `IS_IMPLICITLY_INVOCABLE` VARCHAR(256) NOT NULL,
   `CREATED` VARCHAR(256) NOT NULL,
   `LAST_ALTERED` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `ROUTINE_COLUMNS`;
 Table	Create Table
 ROUTINE_COLUMNS	CREATE TABLE `ROUTINE_COLUMNS` (
@@ -253,7 +253,7 @@
   `DOMAIN_CATALOG` VARCHAR(256) NOT NULL,
   `DOMAIN_SCHEMA` VARCHAR(256) NOT NULL,
   `DOMAIN_NAME` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `SCHEMATA`;
 Table	Create Table
 SCHEMATA	CREATE TABLE `SCHEMATA` (
@@ -263,7 +263,7 @@
   `DEFAULT_CHARACTER_SET_CATALOG` VARCHAR(256) DEFAULT NULL,
   `DEFAULT_CHARACTER_SET_SCHEMA` VARCHAR(256) DEFAULT NULL,
   `DEFAULT_CHARACTER_SET_NAME` VARCHAR(256) DEFAULT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `TABLES`;
 Table	Create Table
 TABLES	CREATE TABLE `TABLES` (
@@ -271,7 +271,7 @@
   `TABLE_SCHEMA` VARCHAR(256) NOT NULL,
   `TABLE_NAME` VARCHAR(256) NOT NULL,
   `TABLE_TYPE` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `TABLE_CONSTRAINTS`;
 Table	Create Table
 TABLE_CONSTRAINTS	CREATE TABLE `TABLE_CONSTRAINTS` (
@@ -284,7 +284,7 @@
   `CONSTRAINT_TYPE` VARCHAR(256) NOT NULL,
   `IS_DEFERRABLE` BOOLEAN NOT NULL,
   `INITIALLY_DEFERRED` BOOLEAN NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `TABLE_PRIVILEGES`;
 Table	Create Table
 TABLE_PRIVILEGES	CREATE TABLE `TABLE_PRIVILEGES` (
@@ -296,7 +296,7 @@
   `COLUMN_NAME` VARCHAR(256) NOT NULL,
   `PRIVILEGE_TYPE` VARCHAR(256) NOT NULL,
   `IS_GRANTABLE` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `VIEWS`;
 Table	Create Table
 VIEWS	CREATE TABLE `VIEWS` (
@@ -306,7 +306,7 @@
   `TABLE_CATALOG` VARCHAR(256) NOT NULL,
   `TABLE_SCHEMA` VARCHAR(256) NOT NULL,
   `TABLE_NAME` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `VIEW_COLUMN_USAGE`;
 Table	Create Table
 VIEW_COLUMN_USAGE	CREATE TABLE `VIEW_COLUMN_USAGE` (
@@ -317,7 +317,7 @@
   `TABLE_SCHEMA` VARCHAR(256) NOT NULL,
   `TABLE_NAME` VARCHAR(256) NOT NULL,
   `COLUMN_NAME` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SHOW CREATE TABLE `VIEW_TABLE_USAGE`;
 Table	Create Table
 VIEW_TABLE_USAGE	CREATE TABLE `VIEW_TABLE_USAGE` (
@@ -327,4 +327,4 @@
   `VIEW_DEFINITION` VARCHAR(256) NOT NULL,
   `CHECK_OPTION` VARCHAR(256) NOT NULL,
   `IS_UPDATABLE` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/innobase/dict/create_replication.cc'
--- plugin/innobase/dict/create_replication.cc	2011-03-22 23:52:29 +0000
+++ plugin/innobase/dict/create_replication.cc	2011-04-04 21:37:55 +0000
@@ -20,6 +20,7 @@
 
 #include <config.h>
 
+#include <drizzled/message.h>
 #include "read_replication.h"
 #include "create_replication.h"
 

=== modified file 'plugin/innobase/tests/r/innodb_cmp.result'
--- plugin/innobase/tests/r/innodb_cmp.result	2011-02-21 17:37:00 +0000
+++ plugin/innobase/tests/r/innodb_cmp.result	2011-04-03 06:02:00 +0000
@@ -15,4 +15,4 @@
   `COMPRESS_TIME` BIGINT NOT NULL,
   `UNCOMPRESS_OPS` BIGINT NOT NULL,
   `UNCOMPRESS_TIME` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/innobase/tests/r/innodb_cmp_reset.result'
--- plugin/innobase/tests/r/innodb_cmp_reset.result	2011-02-21 17:37:00 +0000
+++ plugin/innobase/tests/r/innodb_cmp_reset.result	2011-04-03 06:02:00 +0000
@@ -15,4 +15,4 @@
   `COMPRESS_TIME` BIGINT NOT NULL,
   `UNCOMPRESS_OPS` BIGINT NOT NULL,
   `UNCOMPRESS_TIME` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/innobase/tests/r/innodb_cmpmem.result'
--- plugin/innobase/tests/r/innodb_cmpmem.result	2011-02-21 17:37:00 +0000
+++ plugin/innobase/tests/r/innodb_cmpmem.result	2011-04-03 06:02:00 +0000
@@ -18,4 +18,4 @@
   `PAGES_FREE` BIGINT NOT NULL,
   `RELOCATION_OPS` BIGINT NOT NULL,
   `RELOCATION_TIME` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/innobase/tests/r/innodb_cmpmem_reset.result'
--- plugin/innobase/tests/r/innodb_cmpmem_reset.result	2011-02-21 17:37:00 +0000
+++ plugin/innobase/tests/r/innodb_cmpmem_reset.result	2011-04-03 06:02:00 +0000
@@ -18,4 +18,4 @@
   `PAGES_FREE` BIGINT NOT NULL,
   `RELOCATION_OPS` BIGINT NOT NULL,
   `RELOCATION_TIME` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/innobase/tests/r/innodb_lock_waits.result'
--- plugin/innobase/tests/r/innodb_lock_waits.result	2011-02-21 17:37:00 +0000
+++ plugin/innobase/tests/r/innodb_lock_waits.result	2011-04-03 06:02:00 +0000
@@ -8,4 +8,4 @@
   `REQUESTED_LOCK_ID` VARCHAR(256) NOT NULL,
   `BLOCKING_TRX_ID` VARCHAR(256) NOT NULL,
   `BLOCKING_LOCK_ID` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/innobase/tests/r/innodb_locks.result'
--- plugin/innobase/tests/r/innodb_locks.result	2011-02-21 17:37:00 +0000
+++ plugin/innobase/tests/r/innodb_locks.result	2011-04-03 06:02:00 +0000
@@ -14,4 +14,4 @@
   `LOCK_PAGE` BIGINT NOT NULL,
   `LOCK_REC` BIGINT NOT NULL,
   `LOCK_DATA` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/innobase/tests/r/innodb_replication_log.result'
--- plugin/innobase/tests/r/innodb_replication_log.result	2011-02-21 17:37:00 +0000
+++ plugin/innobase/tests/r/innodb_replication_log.result	2011-04-03 06:02:00 +0000
@@ -12,7 +12,7 @@
   `END_TIMESTAMP` BIGINT NOT NULL,
   `TRANSACTION_MESSAGE_STRING` TEXT COLLATE utf8_general_ci NOT NULL,
   `TRANSACTION_LENGTH` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 select count(*) >= 3 from data_dictionary.INNODB_REPLICATION_LOG;
 count(*) >= 3
 1

=== modified file 'plugin/innobase/tests/r/innodb_status.result'
--- plugin/innobase/tests/r/innodb_status.result	2011-02-21 17:37:00 +0000
+++ plugin/innobase/tests/r/innodb_status.result	2011-04-03 06:02:00 +0000
@@ -7,4 +7,4 @@
 INNODB_STATUS	CREATE TABLE `INNODB_STATUS` (
   `VARIABLE_NAME` VARCHAR(256) NOT NULL,
   `VARIABLE_VALUE` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/innobase/tests/r/innodb_trx.result'
--- plugin/innobase/tests/r/innodb_trx.result	2011-02-21 17:37:00 +0000
+++ plugin/innobase/tests/r/innodb_trx.result	2011-04-03 06:02:00 +0000
@@ -25,7 +25,7 @@
   `TRX_LAST_FOREIGN_KEY_ERROR` VARCHAR(256) DEFAULT NULL,
   `TRX_ADAPTIVE_HASH_LATCHED` BIGINT NOT NULL,
   `TRX_ADAPTIVE_HASH_TIMEOUT` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 use test;
 create table t1 (a int);
 start transaction;

=== modified file 'plugin/logging_stats/tests/r/command.result'
--- plugin/logging_stats/tests/r/command.result	2011-02-21 17:37:00 +0000
+++ plugin/logging_stats/tests/r/command.result	2011-04-03 06:02:00 +0000
@@ -23,7 +23,7 @@
 SESSION_STATEMENTS	CREATE TABLE `SESSION_STATEMENTS` (
   `VARIABLE_NAME` VARCHAR(256) NOT NULL,
   `VARIABLE_VALUE` VARCHAR(1024) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SELECT count(*) FROM data_dictionary.SESSION_STATEMENTS;
 count(*)
 #

=== modified file 'plugin/logging_stats/tests/r/max_user.result'
--- plugin/logging_stats/tests/r/max_user.result	2011-02-21 17:37:00 +0000
+++ plugin/logging_stats/tests/r/max_user.result	2011-04-03 06:02:00 +0000
@@ -524,7 +524,7 @@
 GLOBAL_STATEMENTS	CREATE TABLE `GLOBAL_STATEMENTS` (
   `VARIABLE_NAME` VARCHAR(256) NOT NULL,
   `VARIABLE_VALUE` VARCHAR(1024) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SELECT count(*) FROM data_dictionary.GLOBAL_STATEMENTS;
 count(*)
 #

=== modified file 'plugin/registry_dictionary/tests/r/data_dictionary.result'
--- plugin/registry_dictionary/tests/r/data_dictionary.result	2011-02-21 17:37:00 +0000
+++ plugin/registry_dictionary/tests/r/data_dictionary.result	2011-04-03 06:02:00 +0000
@@ -15,7 +15,7 @@
   `MODULE_LIBRARY` VARCHAR(254) NOT NULL,
   `MODULE_DESCRIPTION` VARCHAR(254) NOT NULL,
   `MODULE_LICENSE` VARCHAR(80) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table PLUGINS ;
 Table	Create Table
 PLUGINS	CREATE TABLE `PLUGINS` (
@@ -23,4 +23,4 @@
   `PLUGIN_TYPE` VARCHAR(256) NOT NULL,
   `IS_ACTIVE` BOOLEAN NOT NULL,
   `MODULE_NAME` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/replication_dictionary/tests/r/data_dictionary.result'
--- plugin/replication_dictionary/tests/r/data_dictionary.result	2011-02-21 17:37:00 +0000
+++ plugin/replication_dictionary/tests/r/data_dictionary.result	2011-04-03 06:02:00 +0000
@@ -7,4 +7,4 @@
 REPLICATION_STREAMS	CREATE TABLE `REPLICATION_STREAMS` (
   `REPLICATOR` VARCHAR(256) NOT NULL,
   `APPLIER` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM

=== modified file 'plugin/schema_dictionary/schemas.cc'
--- plugin/schema_dictionary/schemas.cc	2011-02-22 21:41:05 +0000
+++ plugin/schema_dictionary/schemas.cc	2011-04-03 06:02:00 +0000
@@ -35,6 +35,7 @@
   add_field("SCHEMA_VERSION", plugin::TableFunction::NUMBER, 0, true);
   add_field("SCHEMA_USE_COUNT", plugin::TableFunction::NUMBER, 0, true);
   add_field("IS_REPLICATED", plugin::TableFunction::BOOLEAN, 0, false);
+  add_field("SCHEMA_DEFINER", plugin::TableFunction::STRING, 64, true);
 }
 
 SchemasTool::Generator::Generator(drizzled::Field **arg) :
@@ -81,6 +82,16 @@
     /* IS_REPLICATED */
     push(message::is_replicated(*schema_ptr));
 
+    /* _DEFINER */
+    if (message::has_definer(*schema_ptr))
+    {
+      push(message::definer(*schema_ptr));
+    }
+    else
+    {
+      push();
+    }
+
     return true;
   }
 

=== modified file 'plugin/schema_dictionary/tables.cc'
--- plugin/schema_dictionary/tables.cc	2011-02-22 21:41:05 +0000
+++ plugin/schema_dictionary/tables.cc	2011-04-03 06:02:00 +0000
@@ -59,6 +59,7 @@
   add_field("TABLE_UUID", plugin::TableFunction::STRING, 36, true);
   add_field("TABLE_VERSION", plugin::TableFunction::NUMBER, 0, true);
   add_field("IS_REPLICATED", plugin::TableFunction::BOOLEAN, 0, false);
+  add_field("TABLE_DEFINER", plugin::TableFunction::STRING, 64, true);
 }
 
 TablesTool::Generator::Generator(Field **arg) :
@@ -192,4 +193,14 @@
 
   /* IS_REPLICATED */
   push(message::is_replicated(getTableMessage()));
+
+  /* _DEFINER */
+  if (message::has_definer(getTableMessage()))
+  {
+    push(message::definer(getTableMessage()));
+  }
+  else
+  {
+    push();
+  }
 }

=== modified file 'plugin/schema_dictionary/tests/r/data_dictionary.result'
--- plugin/schema_dictionary/tests/r/data_dictionary.result	2011-03-18 16:53:27 +0000
+++ plugin/schema_dictionary/tests/r/data_dictionary.result	2011-04-04 21:37:55 +0000
@@ -1,7 +1,7 @@
 use data_dictionary;
 SELECT count(*) FROM columns;
 count(*)
-580
+582
 SELECT count(*) FROM indexes;
 count(*)
 2
@@ -403,6 +403,7 @@
 ROW_FORMAT
 SAVEPOINT_NAME
 SCHEMA_CREATION_TIME
+SCHEMA_DEFINER
 SCHEMA_LEVEL_ROUTINE
 SCHEMA_NAME
 SCHEMA_NAME
@@ -461,6 +462,7 @@
 TABLE_COMMENT
 TABLE_COUNT
 TABLE_CREATION_TIME
+TABLE_DEFINER
 TABLE_ID
 TABLE_ID
 TABLE_ID
@@ -631,7 +633,7 @@
   `ENUM_VALUES` VARCHAR(1024) DEFAULT NULL,
   `COLLATION_NAME` VARCHAR(256) NOT NULL,
   `COLUMN_COMMENT` VARCHAR(1024) DEFAULT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table INDEXES ;
 Table	Create Table
 INDEXES	CREATE TABLE `INDEXES` (
@@ -644,7 +646,7 @@
   `KEY_LENGTH` BIGINT NOT NULL,
   `INDEX_TYPE` VARCHAR(256) NOT NULL,
   `INDEX_COMMENT` VARCHAR(1024) DEFAULT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table INDEX_PARTS ;
 Table	Create Table
 INDEX_PARTS	CREATE TABLE `INDEX_PARTS` (
@@ -659,7 +661,7 @@
   `IS_USED_IN_PRIMARY` BOOLEAN NOT NULL,
   `IS_UNIQUE` BOOLEAN NOT NULL,
   `IS_NULLABLE` BOOLEAN NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table REFERENTIAL_CONSTRAINTS ;
 ERROR 42S02: Unknown table 'data_dictionary.REFERENTIAL_CONSTRAINTS'
 show create table SCHEMAS ;
@@ -672,8 +674,9 @@
   `SCHEMA_UUID` VARCHAR(36) DEFAULT NULL,
   `SCHEMA_VERSION` BIGINT DEFAULT NULL,
   `SCHEMA_USE_COUNT` BIGINT DEFAULT NULL,
-  `IS_REPLICATED` BOOLEAN NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+  `IS_REPLICATED` BOOLEAN NOT NULL,
+  `SCHEMA_DEFINER` VARCHAR(64) DEFAULT NULL
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table TABLES ;
 Table	Create Table
 TABLES	CREATE TABLE `TABLES` (
@@ -690,8 +693,9 @@
   `AUTO_INCREMENT` BIGINT NOT NULL,
   `TABLE_UUID` VARCHAR(36) DEFAULT NULL,
   `TABLE_VERSION` BIGINT DEFAULT NULL,
-  `IS_REPLICATED` BOOLEAN NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+  `IS_REPLICATED` BOOLEAN NOT NULL,
+  `TABLE_DEFINER` VARCHAR(64) DEFAULT NULL
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table TABLE_CONSTRAINTS ;
 Table	Create Table
 TABLE_CONSTRAINTS	CREATE TABLE `TABLE_CONSTRAINTS` (
@@ -700,7 +704,7 @@
   `TABLE_SCHEMA` VARCHAR(256) NOT NULL,
   `TABLE_NAME` VARCHAR(256) NOT NULL,
   `CONSTRAINT_TYPE` VARCHAR(256) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 CREATE SCHEMA A;
 use A;
 create table A (a int);
@@ -963,6 +967,7 @@
 DATA_DICTIONARY	SCHEMAS	DEFAULT_COLLATION_NAME
 DATA_DICTIONARY	SCHEMAS	IS_REPLICATED
 DATA_DICTIONARY	SCHEMAS	SCHEMA_CREATION_TIME
+DATA_DICTIONARY	SCHEMAS	SCHEMA_DEFINER
 DATA_DICTIONARY	SCHEMAS	SCHEMA_NAME
 DATA_DICTIONARY	SCHEMAS	SCHEMA_UPDATE_TIME
 DATA_DICTIONARY	SCHEMAS	SCHEMA_USE_COUNT
@@ -1004,6 +1009,7 @@
 DATA_DICTIONARY	TABLES	TABLE_COLLATION
 DATA_DICTIONARY	TABLES	TABLE_COMMENT
 DATA_DICTIONARY	TABLES	TABLE_CREATION_TIME
+DATA_DICTIONARY	TABLES	TABLE_DEFINER
 DATA_DICTIONARY	TABLES	TABLE_NAME
 DATA_DICTIONARY	TABLES	TABLE_SCHEMA
 DATA_DICTIONARY	TABLES	TABLE_TYPE
@@ -1749,6 +1755,7 @@
 SCHEMAS	DATA_DICTIONARY	DEFAULT_COLLATION_NAME
 SCHEMAS	DATA_DICTIONARY	IS_REPLICATED
 SCHEMAS	DATA_DICTIONARY	SCHEMA_CREATION_TIME
+SCHEMAS	DATA_DICTIONARY	SCHEMA_DEFINER
 SCHEMAS	DATA_DICTIONARY	SCHEMA_NAME
 SCHEMAS	DATA_DICTIONARY	SCHEMA_UPDATE_TIME
 SCHEMAS	DATA_DICTIONARY	SCHEMA_USE_COUNT
@@ -1796,6 +1803,7 @@
 TABLES	DATA_DICTIONARY	TABLE_COLLATION
 TABLES	DATA_DICTIONARY	TABLE_COMMENT
 TABLES	DATA_DICTIONARY	TABLE_CREATION_TIME
+TABLES	DATA_DICTIONARY	TABLE_DEFINER
 TABLES	DATA_DICTIONARY	TABLE_NAME
 TABLES	DATA_DICTIONARY	TABLE_SCHEMA
 TABLES	DATA_DICTIONARY	TABLE_TYPE
@@ -2332,6 +2340,7 @@
 SCHEMAS	DATA_DICTIONARY	DEFAULT_COLLATION_NAME
 SCHEMAS	DATA_DICTIONARY	IS_REPLICATED
 SCHEMAS	DATA_DICTIONARY	SCHEMA_CREATION_TIME
+SCHEMAS	DATA_DICTIONARY	SCHEMA_DEFINER
 SCHEMAS	DATA_DICTIONARY	SCHEMA_NAME
 SCHEMAS	DATA_DICTIONARY	SCHEMA_UPDATE_TIME
 SCHEMAS	DATA_DICTIONARY	SCHEMA_USE_COUNT
@@ -2379,6 +2388,7 @@
 TABLES	DATA_DICTIONARY	TABLE_COLLATION
 TABLES	DATA_DICTIONARY	TABLE_COMMENT
 TABLES	DATA_DICTIONARY	TABLE_CREATION_TIME
+TABLES	DATA_DICTIONARY	TABLE_DEFINER
 TABLES	DATA_DICTIONARY	TABLE_NAME
 TABLES	DATA_DICTIONARY	TABLE_SCHEMA
 TABLES	DATA_DICTIONARY	TABLE_TYPE

=== modified file 'plugin/session_dictionary/tests/r/data_dictionary.result'
--- plugin/session_dictionary/tests/r/data_dictionary.result	2011-02-21 17:37:00 +0000
+++ plugin/session_dictionary/tests/r/data_dictionary.result	2011-04-03 06:02:00 +0000
@@ -11,7 +11,7 @@
   `STATE` VARCHAR(256) DEFAULT NULL,
   `INFO` VARCHAR(100) DEFAULT NULL,
   `HAS_GLOBAL_LOCK` BOOLEAN NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SELECT ASSERT(COUNT(ID)) FROM processlist;
 ASSERT(COUNT(ID))
 1

=== modified file 'plugin/status_dictionary/tests/r/data_dictionary.result'
--- plugin/status_dictionary/tests/r/data_dictionary.result	2011-02-21 17:37:00 +0000
+++ plugin/status_dictionary/tests/r/data_dictionary.result	2011-04-03 06:02:00 +0000
@@ -4,25 +4,25 @@
 GLOBAL_STATUS	CREATE TABLE `GLOBAL_STATUS` (
   `VARIABLE_NAME` VARCHAR(256) NOT NULL,
   `VARIABLE_VALUE` VARCHAR(1024) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table GLOBAL_VARIABLES ;
 Table	Create Table
 GLOBAL_VARIABLES	CREATE TABLE `GLOBAL_VARIABLES` (
   `VARIABLE_NAME` VARCHAR(256) NOT NULL,
   `VARIABLE_VALUE` VARCHAR(1024) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table SESSION_STATUS;
 Table	Create Table
 SESSION_STATUS	CREATE TABLE `SESSION_STATUS` (
   `VARIABLE_NAME` VARCHAR(256) NOT NULL,
   `VARIABLE_VALUE` VARCHAR(1024) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 show create table SESSION_VARIABLES;
 Table	Create Table
 SESSION_VARIABLES	CREATE TABLE `SESSION_VARIABLES` (
   `VARIABLE_NAME` VARCHAR(256) NOT NULL,
   `VARIABLE_VALUE` VARCHAR(1024) NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 SELECT count(*) FROM data_dictionary.GLOBAL_STATUS;
 count(*)
 #

=== modified file 'plugin/table_cache_dictionary/tests/r/table_cache.result'
--- plugin/table_cache_dictionary/tests/r/table_cache.result	2011-02-21 17:37:00 +0000
+++ plugin/table_cache_dictionary/tests/r/table_cache.result	2011-04-03 06:02:00 +0000
@@ -10,7 +10,7 @@
   `AVG_ROW_LENGTH` BIGINT NOT NULL,
   `TABLE_SIZE` BIGINT NOT NULL,
   `AUTO_INCREMENT` BIGINT NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 select count(*) FROM data_dictionary.TABLE_CACHE;
 count(*)
 #

=== modified file 'plugin/table_cache_dictionary/tests/r/table_definition_cache.result'
--- plugin/table_cache_dictionary/tests/r/table_definition_cache.result	2011-02-21 17:37:00 +0000
+++ plugin/table_cache_dictionary/tests/r/table_definition_cache.result	2011-04-03 06:02:00 +0000
@@ -6,7 +6,7 @@
   `VERSION` BIGINT NOT NULL,
   `TABLE_COUNT` BIGINT NOT NULL,
   `IS_NAME_LOCKED` BOOLEAN NOT NULL
-) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=FunctionEngine COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 select count(*) FROM data_dictionary.TABLE_DEFINITION_CACHE;
 count(*)
 #

=== modified file 'plugin/transaction_log/tests/r/schema.result'
--- plugin/transaction_log/tests/r/schema.result	2011-01-18 17:30:41 +0000
+++ plugin/transaction_log/tests/r/schema.result	2011-04-03 06:02:00 +0000
@@ -2,7 +2,7 @@
 CREATE SCHEMA my_new_warnings;
 DROP SCHEMA my_new_warnings;
 SET AUTOCOMMIT=0;
-CREATE SCHEMA `my_new_warnings` COLLATE utf8_general_ci;
+CREATE SCHEMA `my_new_warnings` COLLATE utf8_general_ci DEFINER root;
 COMMIT;
 SET AUTOCOMMIT=0;
 DROP SCHEMA `my_new_warnings`;
@@ -10,7 +10,7 @@
 
 Generating statements for innodb replication log
 SET AUTOCOMMIT=0;
-CREATE SCHEMA `my_new_warnings` COLLATE utf8_general_ci;
+CREATE SCHEMA `my_new_warnings` COLLATE utf8_general_ci DEFINER root;
 COMMIT;
 SET AUTOCOMMIT=0;
 DROP SCHEMA `my_new_warnings`;

=== modified file 'plugin/transaction_log/tests/r/transaction_log_schema.result'
--- plugin/transaction_log/tests/r/transaction_log_schema.result	2011-02-07 08:29:23 +0000
+++ plugin/transaction_log/tests/r/transaction_log_schema.result	2011-04-03 06:02:00 +0000
@@ -35,6 +35,9 @@
       UPDATE_TIMESTAMP
       UUID
       version: 1
+      access {
+        definer: "root"
+      }
     }
   }
 }
@@ -199,6 +202,9 @@
       UPDATE_TIMESTAMP
       UUID
       version: 1
+      access {
+        definer: "root"
+      }
     }
     after {
       name: "my_test_schema"

=== modified file 'tests/r/create.result'
--- tests/r/create.result	2011-02-21 17:37:00 +0000
+++ tests/r/create.result	2011-04-03 06:02:00 +0000
@@ -1474,7 +1474,7 @@
   `STATE` VARCHAR(256) DEFAULT NULL,
   `INFO` VARCHAR(100) DEFAULT NULL,
   `HAS_GLOBAL_LOCK` BOOLEAN NOT NULL
-) ENGINE=InnoDB COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=InnoDB COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 drop table t1;
 create temporary table t1 like data_dictionary.processlist;
 Got one of the listed errors
@@ -1491,7 +1491,7 @@
   `STATE` VARCHAR(256) DEFAULT NULL,
   `INFO` VARCHAR(100) DEFAULT NULL,
   `HAS_GLOBAL_LOCK` BOOLEAN NOT NULL
-) ENGINE=MyISAM COLLATE = utf8_general_ci REPLICATE = FALSE
+) ENGINE=MyISAM COLLATE = utf8_general_ci REPLICATE = FALSE DEFINER SYSTEM
 drop table t1;
 
 # --

=== modified file 'tests/r/data_dictionary_like_info.result'
--- tests/r/data_dictionary_like_info.result	2011-02-22 21:41:05 +0000
+++ tests/r/data_dictionary_like_info.result	2011-04-03 06:02:00 +0000
@@ -339,11 +339,11 @@
 select * from `data_dictionary`.`INDEXES` where `TABLE_NAME` = NULL;
 TABLE_SCHEMA	TABLE_NAME	INDEX_NAME	IS_USED_IN_PRIMARY	IS_UNIQUE	IS_NULLABLE	KEY_LENGTH	INDEX_TYPE	INDEX_COMMENT
 select * from data_dictionary.schemas where schema_name = NULL;
-SCHEMA_NAME	DEFAULT_COLLATION_NAME	SCHEMA_CREATION_TIME	SCHEMA_UPDATE_TIME	SCHEMA_UUID	SCHEMA_VERSION	SCHEMA_USE_COUNT	IS_REPLICATED
+SCHEMA_NAME	DEFAULT_COLLATION_NAME	SCHEMA_CREATION_TIME	SCHEMA_UPDATE_TIME	SCHEMA_UUID	SCHEMA_VERSION	SCHEMA_USE_COUNT	IS_REPLICATED	SCHEMA_DEFINER
 select * from data_dictionary.tables where table_schema = NULL;
-TABLE_SCHEMA	TABLE_NAME	TABLE_TYPE	TABLE_ARCHETYPE	ENGINE	ROW_FORMAT	TABLE_COLLATION	TABLE_CREATION_TIME	TABLE_UPDATE_TIME	TABLE_COMMENT	AUTO_INCREMENT	TABLE_UUID	TABLE_VERSION	IS_REPLICATED
+TABLE_SCHEMA	TABLE_NAME	TABLE_TYPE	TABLE_ARCHETYPE	ENGINE	ROW_FORMAT	TABLE_COLLATION	TABLE_CREATION_TIME	TABLE_UPDATE_TIME	TABLE_COMMENT	AUTO_INCREMENT	TABLE_UUID	TABLE_VERSION	IS_REPLICATED	TABLE_DEFINER
 select * from data_dictionary.tables where table_name = NULL;
-TABLE_SCHEMA	TABLE_NAME	TABLE_TYPE	TABLE_ARCHETYPE	ENGINE	ROW_FORMAT	TABLE_COLLATION	TABLE_CREATION_TIME	TABLE_UPDATE_TIME	TABLE_COMMENT	AUTO_INCREMENT	TABLE_UUID	TABLE_VERSION	IS_REPLICATED
+TABLE_SCHEMA	TABLE_NAME	TABLE_TYPE	TABLE_ARCHETYPE	ENGINE	ROW_FORMAT	TABLE_COLLATION	TABLE_CREATION_TIME	TABLE_UPDATE_TIME	TABLE_COMMENT	AUTO_INCREMENT	TABLE_UUID	TABLE_VERSION	IS_REPLICATED	TABLE_DEFINER
 #
 # Test that the query is visible to self and others.
 #

=== added directory 'tests/suite/access'
=== added directory 'tests/suite/access/r'
=== added file 'tests/suite/access/r/definer_schema.result'
--- tests/suite/access/r/definer_schema.result	1970-01-01 00:00:00 +0000
+++ tests/suite/access/r/definer_schema.result	2011-04-03 06:02:00 +0000
@@ -0,0 +1,8 @@
+CREATE SCHEMA A;
+SHOW CREATE SCHEMA A;
+Database	Create Database
+A	CREATE DATABASE `A` COLLATE = utf8_general_ci
+SELECT SCHEMA_NAME, SCHEMA_DEFINER FROM DATA_DICTIONARY.SCHEMAS WHERE SCHEMA_NAME="A";
+SCHEMA_NAME	SCHEMA_DEFINER
+A	root
+DROP SCHEMA A;

=== added file 'tests/suite/access/r/definer_table.result'
=== added directory 'tests/suite/access/t'
=== added file 'tests/suite/access/t/definer_schema.test'
--- tests/suite/access/t/definer_schema.test	1970-01-01 00:00:00 +0000
+++ tests/suite/access/t/definer_schema.test	2011-04-03 06:02:00 +0000
@@ -0,0 +1,6 @@
+CREATE SCHEMA A;
+SHOW CREATE SCHEMA A;
+
+SELECT SCHEMA_NAME, SCHEMA_DEFINER FROM DATA_DICTIONARY.SCHEMAS WHERE SCHEMA_NAME="A";
+
+DROP SCHEMA A;

=== added file 'tests/suite/access/t/definer_test.test'
--- tests/suite/access/t/definer_test.test	1970-01-01 00:00:00 +0000
+++ tests/suite/access/t/definer_test.test	2011-04-03 06:02:00 +0000
@@ -0,0 +1,3 @@
+CREATE TABLE A (A SERIAL) DEFINER "mine";
+SHOW CREATE TABLE A;
+DROP TABLE A;

